﻿using System; 
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Collections;
using System.Linq;
using Api;

namespace ViplexCreSample
{
    public partial class Form1 : Form
    {
        private string Result;
        static Api.exportViplexCallback s_callback;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string imgPath = System.Environment.CurrentDirectory + "/media/a.jpg";
            imgPath = imgPath.Replace("\\", "/");
            this.richTextBox1.Text = "{\"sn\":\"BZSA17466W0X20004912\",\"username\":\"admin\",\"password\":\"123456\",\"loginType\":0,\"rememberPwd\":0}";
            this.richTextBox2.Text = "{\"name\":\"jiemu1\",\"width\":400,\"height\":400,\"tplID\":1,\"winInfo\":{\"height\":100,\"width\":100,\"left\":0,\"top\":0,\"zindex\":0,\"index\":0}}";
            this.richTextBox3.Text = "{\"programID\":1,\"pageID\":1,\"pageInfo\":{\"name\":\"jiemu01\",\"widgetContainers\":[{\"contents\":{\"widgets\":[{\"constraints\":[{\"cron\":[\"0 0 0 ? * 1,2,3,4,5,6,7\"],\"endTime\":\"4017-12-30T23:59:59Z+8:00\",\"startTime\":\"1970-01-01T00:00:00Z+8:00\"}],\"duration\":5000,\"dataSource\":\"03239f2a508f02be2c3d190fd6d7b744.jpg\",\"type\":\"PICTURE\",\"name\":\"a.jpg\",\"originalDataSource\":\"" + imgPath + "\"}]},\"id\":1,\"name\":\"widgetContainers1\"}]}}";
            this.richTextBox4.Text = "{\"programID\":1,\"outPutPath\":\"c:/program/\"}";
            this.richTextBox5.Text = "{\"sn\": \"BZSA17466W0X20004912\",\"iconPath\": \"\",\"iconName\": \"\",\"sendProgramFilePaths\": {\"programPath\": \"C:/program/program1\",\"mediasPath\": {\"" + imgPath + "\": \"a.jpg\"}},\"programName\": \"jiemu01\",\"deviceIdentifier\": \"\",\"startPlayAfterTransferred\": true,\"insertPlay\": true}";
            this.richTextBox8.Text = "{\"ip\":\"172.18.179.106\"}";
            this.richTextBox9.Text = "{\"sn\":\"BZSA17466W0X20004912\"}";
            this.richTextBox10.Text = "{\"sn\":\"BZSA17466W0X20004912\",\"taskInfo\":{\"state\":\"open\"}}";
            this.richTextBox11.Text = "{\"sn\":\"BZSA17466W0X20004912\",\"taskInfo\":{\"type\":\"REBOOT\",\"source\":{\"type\":0,\"platform\":1},\"executionType\":\"IMMEDIATELY\",\"reason\":\"Just to test\",\"conditions\":[{\"cron\":[\"0 15 10 ? * *\",\"0 0 12 * * ?\"],\"enable\":true}]}}";
            this.richTextBox12.Text = "{\"sn\":\"BZSA17466W0X20004912\"}";
            //this.richTextBox13.Text = "{\"sn\":\"BZSA07293J0320000774\",\"width\":100,\"height\":100,\"downLoadDirectoryPath\":\"d://\",\"pictureName\":\"a.png\",\"pictureType\":1}";
            this.richTextBox13.Text = "{\"company\":\"NovaStar\",\"phone\":\"029-68216000\",\"email\":\"hr@novastar.tech\"}";

            s_callback = callback;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string sdkRootDir = "c:/sdk";
            string requestData = this.richTextBox13.Text;
            ApiTester.NvInitW(GetUtf8String(sdkRootDir), GetUtf8String(requestData));
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Result = "";
            ApiTester.NvSearchTerminalAsyncW(callback);
        }

        private byte[] GetUtf8String(string gb2312Str)
        {
            Encoding utf8 = Encoding.GetEncoding("UTF-8");
            Encoding gb2312 = Encoding.GetEncoding("GB2312");


            byte[] gb = gb2312.GetBytes(gb2312Str);
            gb = Encoding.Convert(gb2312, utf8, gb);
            string utf8Str = utf8.GetString(gb);

            return gb;
            //return utf8Str;
        }

        private void callback(int code, string des)
        {
            Result += des;

            Result += "\n\n\n\n";

            Console.WriteLine("callback return : " + code + des);
            MethodInvoker mi = new MethodInvoker(() =>
            {
                this.richTextBox7.Text = code.ToString();
                this.richTextBox6.Text = Result;
            });
            this.BeginInvoke(mi);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Result = "";

            string requestData = this.richTextBox1.Text;

            ApiTester.NvLoginAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox2.Text;
            ApiTester.NvCreateProgramAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox3.Text;
            ApiTester.NvSetPageProgramAsyncW(GetUtf8String(requestData), callback);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox4.Text;
            ApiTester.NvMakeProgramAsyncW(GetUtf8String(requestData), callback);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox5.Text;
            ApiTester.NvStartTransferProgramAsyncW(GetUtf8String(requestData), s_callback);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            Result = "";
            OpenFileDialog openfile = new OpenFileDialog();

            openfile.Title = "请选择要发送的文件";
            openfile.Filter = "所有文件类型|*.*";
            if (DialogResult.OK == openfile.ShowDialog())
            {
                string requestData = "{\"filePath\":\"" + openfile.FileName.Replace("\\", "/") + "\"}";
                ApiTester.NvGetFileMD5AsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
            }
        }

        private void button5_Click_1(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox8.Text;
            ApiTester.NvSearchAppointIpAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox9.Text;
            ApiTester.NvGetProgramInfoAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox12.Text;
            ApiTester.NvGetVPNConnectInfoAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox11.Text;
            ApiTester.NvSetScreenPowerStateAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button11_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox10.Text;
            ApiTester.NvSetReBootTaskAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }

        private void button12_Click(object sender, EventArgs e)
        {
            Result = "";
            string requestData = this.richTextBox13.Text;
            ApiTester.NvDownLoadScreenshotAsyncW(System.Text.Encoding.UTF8.GetBytes(requestData), callback);
        }
    }
}
